/**
*	A robot named Karel likes to take long, meandering walks in the woods
*	in the world, and even though it has a built-in compass the robot 
*	sometimes cannot find its way home. To alleviate the problem, before 
*	Karel walks in the woods the robot fills its beeper bag and then it 
*	leaves a trail of beepers. 
*/

package kareltherobot;

class PathFinder extends Robot {

	public PathFinder(int street, int avenue, int direction, int howmany) {
	
		super(street, avenue, direction, howmany);
	}
	
	public void turnRight() {
	  turnLeft(); 
	  turnLeft();
	  turnLeft();
	 }
	 // method checkEast assumes that the robot is facing east and chesks
	 // whether there is a beeper in front of him.if so return true
	 // otherwise return false
	 public boolean checkEast(){
	    move();
	    if (nextToABeeper())
	      {
	       turnLeft(); turnLeft();
	       move();
	       turnRight(); turnRight();
	       return true;
	      }
	     else 
	      {  turnLeft(); turnLeft();
	         move();
	         turnRight(); turnRight();
	         return false;
	      }
	       
	 
	 }
	 // complete checkWest, checkNorth, checkSouth methods
	 
	 // pseudo code
	 public  void tour(){
	   /*
	    if facing east  checkEast
	     if a beeper is found move east
	     if not check north, if a beeper s found move north
	     if not check west, if a beeoer is found move west
	     if not check south, if a beeper is found move south
	   */
	 }
	 
	 // RECURSION EXAMPLE
	 // TAIL RECURSION
	 public void moveRecursively() {
	    if (nextToABeeper())
	      { pickBeeper();
	        move();
	        moveRecursively();	
	      }  
	    
	 }   
	    // define and implement other new instructions here
	
}